   1              		.syntax unified
   2              		.cpu cortex-m3
   3              		.fpu softvfp
   4              		.eabi_attribute 20, 1
   5              		.eabi_attribute 21, 1
   6              		.eabi_attribute 23, 3
   7              		.eabi_attribute 24, 1
   8              		.eabi_attribute 25, 1
   9              		.eabi_attribute 26, 1
  10              		.eabi_attribute 30, 4
  11              		.eabi_attribute 18, 2
  12              		.thumb
  13              		.file	"spar_setup.c"
  14              		.text
  15              	.Ltext0:
  16              		.cfi_sections	.debug_frame
  17              		.section	.spar_setup,"ax",%progbits
  18              		.align	1
  19              		.global	BLE_IO_BOARD_FOR_TEST_spar_crt_setup
  20              		.thumb
  21              		.thumb_func
  23              	BLE_IO_BOARD_FOR_TEST_spar_crt_setup:
  24              	.LFB0:
  25              		.file 1 "common/spar_setup.c"
   1:common/spar_setup.c **** /*
   2:common/spar_setup.c **** ********************************************************************
   3:common/spar_setup.c **** * THIS INFORMATION IS PROPRIETARY TO BROADCOM CORP.
   4:common/spar_setup.c **** *-------------------------------------------------------------------
   5:common/spar_setup.c **** *
   6:common/spar_setup.c **** *           Copyright (c) 2007 Broadcom Corp.
   7:common/spar_setup.c **** *                  ALL RIGHTS RESERVED
   8:common/spar_setup.c **** *
   9:common/spar_setup.c **** ********************************************************************
  10:common/spar_setup.c **** 
  11:common/spar_setup.c **** ********************************************************************
  12:common/spar_setup.c **** *    File Name: spar_setup.c
  13:common/spar_setup.c **** *
  14:common/spar_setup.c **** *           The Stackable Patch and Application Runtime
  15:common/spar_setup.c **** *
  16:common/spar_setup.c **** *    Abstract: C-runtime setup of this SPAR tier
  17:common/spar_setup.c **** *
  18:common/spar_setup.c **** ********************************************************************
  19:common/spar_setup.c **** */
  20:common/spar_setup.c **** 
  21:common/spar_setup.c **** #include "spar_utils.h"
  22:common/spar_setup.c **** #include "string.h"
  23:common/spar_setup.c **** #include "types.h"
  24:common/spar_setup.c **** 
  25:common/spar_setup.c **** /*****************************************************************
  26:common/spar_setup.c **** *   Definitions
  27:common/spar_setup.c **** *
  28:common/spar_setup.c **** *****************************************************************/
  29:common/spar_setup.c **** 
  30:common/spar_setup.c **** #ifndef SPAR_APP_SETUP
  31:common/spar_setup.c **** #error "You must define SPAR_APP_SETUP to indicate the application setup."
  32:common/spar_setup.c **** #endif
  33:common/spar_setup.c **** 
  34:common/spar_setup.c **** void SPAR_APP_SETUP(void);
  35:common/spar_setup.c **** 
  36:common/spar_setup.c **** extern char* idle_saveThreadxAvailMem;
  37:common/spar_setup.c **** extern void install_libs(void);
  38:common/spar_setup.c **** 
  39:common/spar_setup.c **** #ifdef DEBUG
  40:common/spar_setup.c **** UINT8 spar_debug_continue = 0;
  41:common/spar_setup.c **** #endif
  42:common/spar_setup.c **** 
  43:common/spar_setup.c **** /*****************************************************************
  44:common/spar_setup.c ****  *   Function: spar_setup()
  45:common/spar_setup.c ****  *
  46:common/spar_setup.c ****  *   Abstract: Process the information in .secinfo, copying and
  47:common/spar_setup.c ****  *   clearing sections as needed.
  48:common/spar_setup.c ****  *
  49:common/spar_setup.c ****  *
  50:common/spar_setup.c ****  *****************************************************************/
  51:common/spar_setup.c **** #ifndef __GNUC__
  52:common/spar_setup.c **** #pragma arm section code = "spar_setup"
  53:common/spar_setup.c **** void SPAR_CRT_SETUP(void)
  54:common/spar_setup.c **** {
  55:common/spar_setup.c ****     typedef struct
  56:common/spar_setup.c ****     {
  57:common/spar_setup.c ****         UINT32 source;
  58:common/spar_setup.c ****         UINT32 target;
  59:common/spar_setup.c ****         UINT32 len;
  60:common/spar_setup.c ****     } armlink_copy_secinfo_t;
  61:common/spar_setup.c ****     
  62:common/spar_setup.c ****     extern void *_tx_initialize_unused_memory;
  63:common/spar_setup.c ****     extern UINT32 Region$$Table$$Base;
  64:common/spar_setup.c ****     extern UINT32 Region$$Table$$Limit;
  65:common/spar_setup.c ****     
  66:common/spar_setup.c ****     extern UINT32 Image$$SPAR_DRAM_ZI_AREA$$ZI$$Base;
  67:common/spar_setup.c ****     extern UINT32 Image$$SPAR_DRAM_ZI_AREA$$ZI$$Length;
  68:common/spar_setup.c ****     extern UINT32 Image$$first_free_section_in_spar_NV_RAM$$Base;
  69:common/spar_setup.c ****     
  70:common/spar_setup.c ****     armlink_copy_secinfo_t *cpysecinfo;
  71:common/spar_setup.c ****     
  72:common/spar_setup.c ****     // Get the section info base of this spar slice
  73:common/spar_setup.c ****     UINT32 cpysecinfobase = (UINT32)&Region$$Table$$Base;
  74:common/spar_setup.c ****     UINT32 cpysecinfolim = (UINT32)&Region$$Table$$Limit;
  75:common/spar_setup.c ****     
  76:common/spar_setup.c ****     UINT32 clrsecbase = (UINT32)&Image$$SPAR_DRAM_ZI_AREA$$ZI$$Base;
  77:common/spar_setup.c ****     UINT32 clrseclen = (UINT32)&Image$$SPAR_DRAM_ZI_AREA$$ZI$$Length;
  78:common/spar_setup.c ****     UINT32 endofspar = (UINT32)&Image$$first_free_section_in_spar_NV_RAM$$Base;
  79:common/spar_setup.c ****     
  80:common/spar_setup.c ****     // Here we ought to assert that we're linked against the right
  81:common/spar_setup.c ****     // image, before we call memcpy/memset in ROM/Flash...
  82:common/spar_setup.c ****     
  83:common/spar_setup.c ****     if(cpysecinfobase != cpysecinfolim)
  84:common/spar_setup.c ****     {
  85:common/spar_setup.c ****         // Section info length is not zero
  86:common/spar_setup.c ****         // which means that there is RW data
  87:common/spar_setup.c ****         cpysecinfo = (armlink_copy_secinfo_t *)cpysecinfobase;
  88:common/spar_setup.c ****         memcpy((void *)cpysecinfo->target, (void *)cpysecinfo->source, cpysecinfo->len);
  89:common/spar_setup.c ****     }
  90:common/spar_setup.c ****     
  91:common/spar_setup.c ****     // Clear ZI section
  92:common/spar_setup.c ****     if(clrseclen != 0)
  93:common/spar_setup.c ****         memset((void *)clrsecbase, 0x00, clrseclen);
  94:common/spar_setup.c ****     
  95:common/spar_setup.c ****     // And move avail memory above this spar if required
  96:common/spar_setup.c ****     // Note that if there are other spars will be placed with minimum
  97:common/spar_setup.c ****     // alignment (because of the linker option to IRAM_SPAR_BEGIN) and itself
  98:common/spar_setup.c ****     // is responsible for moving the avail mem ptr.
  99:common/spar_setup.c ****    	idle_saveThreadxAvailMem = (char *)endofspar;
 100:common/spar_setup.c **** 	
 101:common/spar_setup.c **** 	// Install included libraries and patches if any
 102:common/spar_setup.c **** 	install_libs();
 103:common/spar_setup.c ****     
 104:common/spar_setup.c ****     // Call the application setup code
 105:common/spar_setup.c ****     SPAR_APP_SETUP();
 106:common/spar_setup.c **** }
 107:common/spar_setup.c **** #pragma arm section code
 108:common/spar_setup.c **** 
 109:common/spar_setup.c **** #else
 110:common/spar_setup.c **** 
 111:common/spar_setup.c **** ATTRIBUTE((section(".spar_setup")))
 112:common/spar_setup.c **** void SPAR_CRT_SETUP(void)
 113:common/spar_setup.c **** {
  26              		.loc 1 113 0
  27              		.cfi_startproc
  28              		@ args = 0, pretend = 0, frame = 0
  29              		@ frame_needed = 0, uses_anonymous_args = 0
 114:common/spar_setup.c ****     extern void* spar_iram_bss_begin;
 115:common/spar_setup.c ****     extern unsigned spar_iram_data_length, spar_iram_bss_length;
 116:common/spar_setup.c ****     extern void* spar_irom_data_begin, *spar_iram_data_begin, *spar_iram_end;
 117:common/spar_setup.c **** 
 118:common/spar_setup.c ****     // Initialize initialized data if .data length is non-zero and it needs to be copied from NV to
 119:common/spar_setup.c ****     if(((UINT32)&spar_irom_data_begin != (UINT32)&spar_iram_data_begin) && ((UINT32)&spar_iram_data
  30              		.loc 1 119 0
  31 0000 0B48     		ldr	r0, .L3
  32 0002 0C49     		ldr	r1, .L3+4
 113:common/spar_setup.c **** {
  33              		.loc 1 113 0
  34 0004 08B5     		push	{r3, lr}
  35              	.LCFI0:
  36              		.cfi_def_cfa_offset 8
  37              		.cfi_offset 14, -4
  38              		.cfi_offset 3, -8
  39              		.loc 1 119 0
  40 0006 8842     		cmp	r0, r1
  41 0008 02D0     		beq	.L2
 120:common/spar_setup.c ****         memcpy((void*)&spar_iram_data_begin, (void*)&spar_irom_data_begin, (UINT32)&spar_iram_data_
  42              		.loc 1 120 0
  43 000a 0B4A     		ldr	r2, .L3+8
  44 000c FFF7FEFF 		bl	__aeabi_memcpy
  45              	.L2:
 121:common/spar_setup.c ****     
 122:common/spar_setup.c ****     // // Clear the ZI section
 123:common/spar_setup.c ****     if((UINT32)&spar_iram_bss_length != 0)
 124:common/spar_setup.c ****     {
 125:common/spar_setup.c ****         memset((void*)&spar_iram_bss_begin, 0x00, (UINT32)&spar_iram_bss_length);
  46              		.loc 1 125 0
  47 0010 0A49     		ldr	r1, .L3+12
  48 0012 0022     		movs	r2, #0
  49 0014 0A48     		ldr	r0, .L3+16
  50 0016 FFF7FEFF 		bl	__aeabi_memset
 126:common/spar_setup.c ****     }
 127:common/spar_setup.c ****     
 128:common/spar_setup.c ****     // And move avail memory above this spar if required
 129:common/spar_setup.c ****     // Note that if there are other spars will be placed with minimum
 130:common/spar_setup.c ****     // alignment (because of the linker option to IRAM_SPAR_BEGIN) and itself
 131:common/spar_setup.c ****     // is responsible for moving the avail mem ptr.
 132:common/spar_setup.c ****    	idle_saveThreadxAvailMem = (char *)(((UINT32)&spar_iram_end + 32) & 0xFFFFFFF0);
  51              		.loc 1 132 0
  52 001a 0A4A     		ldr	r2, .L3+20
  53 001c 0A4B     		ldr	r3, .L3+24
  54 001e 22F00F02 		bic	r2, r2, #15
  55 0022 1A60     		str	r2, [r3, #0]
 133:common/spar_setup.c **** 
 134:common/spar_setup.c **** 	// Install included libraries and patches if any
 135:common/spar_setup.c **** 	install_libs();
  56              		.loc 1 135 0
  57 0024 FFF7FEFF 		bl	install_libs
 136:common/spar_setup.c **** 	
 137:common/spar_setup.c ****     // Call the application setup code
 138:common/spar_setup.c ****     SPAR_APP_SETUP();
 139:common/spar_setup.c **** }
  58              		.loc 1 139 0
  59 0028 BDE80840 		pop	{r3, lr}
 138:common/spar_setup.c ****     SPAR_APP_SETUP();
  60              		.loc 1 138 0
  61 002c FFF7FEBF 		b	application_setup
  62              	.L4:
  63              		.align	2
  64              	.L3:
  65 0030 00000000 		.word	spar_iram_data_begin
  66 0034 00000000 		.word	spar_irom_data_begin
  67 0038 00000000 		.word	spar_iram_data_length
  68 003c 00000000 		.word	spar_iram_bss_length
  69 0040 00000000 		.word	spar_iram_bss_begin
  70 0044 20000000 		.word	spar_iram_end+32
  71 0048 00000000 		.word	idle_saveThreadxAvailMem
  72              		.cfi_endproc
  73              	.LFE0:
  75              		.text
  76              	.Letext0:
  77              		.file 2 "../inc/types.h"
